=== debian/changelog ===
sunpinyin (2.0.2-0ubuntu2) maverick; urgency=low

  * Fix endianness check on armel. LP: #642113.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 18 Sep 2010 18:45:53 +0200

sunpinyin (2.0.2-0ubuntu1) maverick; urgency=low

  * Initial Ubuntu upload, LP: #631472, LP: #631459

 -- Zhengpeng Hou <zhengpeng-hou@ubuntu.com>  Mon, 06 Sep 2010 12:23:46 +0100

sunpinyin (2.0.2-1) experimental; urgency=low

  * Initial release (Closes: #478811)

 -- Liang Guo <bluestonechina@gmail.com>  Wed, 18 Aug 2010 16:47:54 +0800
