=== debian/changelog ===
sunpinyin (2.0.3~rc1-0ubuntu1) natty; urgency=low

  * New upstream release
  * Drop bump-new-pkgconfig-version.patch, arm-endianess.patch as its
    incorporated upstream
  * Refresh all remaining patches

 -- Bhavani Shankar <bhavi@ubuntu.com>  Thu, 25 Nov 2010 12:45:23 +0530
