=== debian/changelog ===
sunpinyin (2.0.3-2ubuntu1) oneiric; urgency=low

  * Add debian/libsunpinyin3.symbols.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Fri, 01 Jul 2011 17:43:29 +0100

sunpinyin (2.0.3-2) unstable; urgency=low

  * Build with prefix=$(DEB_DESTDIR)/usr (Close: #617752)
  * Fix FTBFS on SH (Close: #617753)
  * Fix FTBFS on MIPSEL.

 -- Liang Guo <bluestonechina@gmail.com>  Tue, 15 Mar 2011 00:20:57 +0800

sunpinyin (2.0.3-1) unstable; urgency=low

  * New Upstream Version 2.0.3.
  * Upload to unstable.
  * Update VCS field in debian/control.

 -- Liang Guo <bluestonechina@gmail.com>  Sat, 19 Feb 2011 10:38:38 +0800
