=== debian/rules ===
--- 
+++ 
@@ -14,12 +14,12 @@
   CXXFLAGS += -g
 endif
 
-CXXFLAGS += -pipe -DHAVE_CONFIG_H -DSUNPINYIN_DATA_DIR="/usr/lib/sunpinyin/data"
+CXXFLAGS += -pipe
 
 build: build-stamp
 build-stamp: 
 	dh_quilt_patch
-	-$(SCONS)
+	-$(SCONS)  --prefix=$(DEB_DESTDIR)/usr 
 	for p in $(PROGS); do $(POD2MAN) --section 1 doc/$$p.pod > doc/$$p.1; done
 	touch build-stamp
 
@@ -30,7 +30,7 @@
 	-$(SCONS) -c
 	-rm -r config.log config.h	\
 		.sconf_temp .sconsign.dblite \
-		src/host_os.h sunpinyin-2.0.pc
+		configure.conf sunpinyin-2.0.pc
 	-for p in $(PROGS); do rm doc/$$p.1; done
 	dh_quilt_unpatch
 	dh_clean
