=== debian/watch ===
version=3
http://googlecode.debian.net/p/sunpinyin/sunpinyin-(\d+.*).tar.gz
